Index: cpukit/Makefile.am
===================================================================
--- cpukit/Makefile.am	(revision d51538bdbe5ea9e71a7205e39fcef387fbdb4b39)
+++ cpukit/Makefile.am	(revision d2e31f70c12f6363cef79ffad781df6ec0acdfb5)
@@ -91,5 +91,5 @@
 include_rtems_rtl_HEADERS += libdl/rtl-fwd.h libdl/rtl-obj.h libdl/rtl-obj-cache.h
 include_rtems_rtl_HEADERS += libdl/rtl-obj-comp.h libdl/rtl-unresolved.h
-include_rtems_rtl_HEADERS += libdl/rtl-indirect-ptr.h libdl/rtl-sym.h
+include_rtems_rtl_HEADERS += libdl/rtl-indirect-ptr.h libdl/rtl-sym.h libdl/rtl-trace.h
 include_rtems_rtl_HEADERS += libdl/rap.h libdl/rap-shell.h
 endif
Index: cpukit/libdl/Makefile.am
===================================================================
--- cpukit/libdl/Makefile.am	(revision d51538bdbe5ea9e71a7205e39fcef387fbdb4b39)
+++ cpukit/libdl/Makefile.am	(revision d2e31f70c12f6363cef79ffad781df6ec0acdfb5)
@@ -26,4 +26,5 @@
   rtl-sym.c \
   rtl-trace.c \
+  rtl-unwind-dw2.c \
   rtl-unresolved.c
 
Index: cpukit/libdl/include/arch/arm/machine/elf_machdep.h
===================================================================
--- cpukit/libdl/include/arch/arm/machine/elf_machdep.h	(revision d51538bdbe5ea9e71a7205e39fcef387fbdb4b39)
+++ cpukit/libdl/include/arch/arm/machine/elf_machdep.h	(revision d2e31f70c12f6363cef79ffad781df6ec0acdfb5)
@@ -81,5 +81,6 @@
 #define R_ARM_ALU_SBREL_27_20	37
 #define R_ARM_V4BX        40
-#define R_ARM_PREL31      41
+#define R_ARM_TARGET2     41
+#define R_ARM_PREL31      42
 
 #define R_ARM_MOVW_ABS_NC     43
Index: cpukit/libdl/include/sys/exec_elf.h
===================================================================
--- cpukit/libdl/include/sys/exec_elf.h	(revision d51538bdbe5ea9e71a7205e39fcef387fbdb4b39)
+++ cpukit/libdl/include/sys/exec_elf.h	(revision d2e31f70c12f6363cef79ffad781df6ec0acdfb5)
@@ -460,4 +460,8 @@
 #define	SHF_ALLOC	0x2		/* Section occupies memory */
 #define	SHF_EXECINSTR	0x4		/* Section contains executable insns */
+#define	SHF_MERGE	0x10		/* Section contains data that can be merged */
+#define	SHF_STRINGS	0x20		/* Section contains null-terminated strings */
+#define	SHF_INFO_LINK	0x40		/* Section header's sh_info holds table index */
+#define	SHF_LINK_ORDER	0x80		/* Section has special ordering requirements */
 
 #define	SHF_MASKOS	0x0f000000	/* Operating system specific values */
@@ -950,5 +954,5 @@
 
 /*
- * These constants are used for Elf32_Verdef struct's version number.  
+ * These constants are used for Elf32_Verdef struct's version number.
  */
 #define VER_DEF_NONE		0
@@ -956,5 +960,5 @@
 
 /*
- * These constants are used for Elf32_Verdef struct's vd_flags.  
+ * These constants are used for Elf32_Verdef struct's vd_flags.
  */
 #define VER_FLG_BASE		0x1
@@ -968,5 +972,5 @@
 
 /*
- * These constants are used for Elf32_Verneed struct's version number.  
+ * These constants are used for Elf32_Verneed struct's version number.
  */
 #define	VER_NEED_NONE		0
Index: cpukit/libdl/rap.c
===================================================================
--- cpukit/libdl/rap.c	(revision d51538bdbe5ea9e71a7205e39fcef387fbdb4b39)
+++ cpukit/libdl/rap.c	(revision d2e31f70c12f6363cef79ffad781df6ec0acdfb5)
@@ -20,4 +20,5 @@
 #endif
 
+#include <stdarg.h>
 #include <stdlib.h>
 #include <stdio.h>
Index: cpukit/libdl/rtl-allocator.c
===================================================================
--- cpukit/libdl/rtl-allocator.c	(revision d51538bdbe5ea9e71a7205e39fcef387fbdb4b39)
+++ cpukit/libdl/rtl-allocator.c	(revision d2e31f70c12f6363cef79ffad781df6ec0acdfb5)
@@ -153,4 +153,5 @@
 rtems_rtl_alloc_module_new (void** text_base, size_t text_size,
                             void** const_base, size_t const_size,
+                            void** eh_base, size_t eh_size,
                             void** data_base, size_t data_size,
                             void** bss_base, size_t bss_size)
@@ -174,5 +175,18 @@
     if (!*const_base)
     {
-      rtems_rtl_alloc_module_del (text_base, const_base, data_base, bss_base);
+      rtems_rtl_alloc_module_del (text_base, const_base, eh_base,
+                                  data_base, bss_base);
+      return false;
+    }
+  }
+
+  if (eh_size)
+  {
+    *eh_base = rtems_rtl_alloc_new (RTEMS_RTL_ALLOC_READ,
+                                    eh_size, false);
+    if (!*eh_base)
+    {
+      rtems_rtl_alloc_module_del (text_base, const_base, eh_base,
+                                  data_base, bss_base);
       return false;
     }
@@ -185,5 +199,6 @@
     if (!*data_base)
     {
-      rtems_rtl_alloc_module_del (text_base, const_base, data_base, bss_base);
+      rtems_rtl_alloc_module_del (text_base, const_base, eh_base,
+                                  data_base, bss_base);
       return false;
     }
@@ -196,5 +211,6 @@
     if (!*bss_base)
     {
-      rtems_rtl_alloc_module_del (text_base, const_base, data_base, bss_base);
+      rtems_rtl_alloc_module_del (text_base, const_base, eh_base,
+                                  data_base, bss_base);
       return false;
     }
@@ -207,4 +223,5 @@
 rtems_rtl_alloc_module_del (void** text_base,
                             void** const_base,
+                            void** eh_base,
                             void** data_base,
                             void** bss_base)
@@ -212,6 +229,7 @@
   rtems_rtl_alloc_del (RTEMS_RTL_ALLOC_READ_WRITE, *bss_base);
   rtems_rtl_alloc_del (RTEMS_RTL_ALLOC_READ_WRITE, *data_base);
+  rtems_rtl_alloc_del (RTEMS_RTL_ALLOC_READ, *eh_base);
   rtems_rtl_alloc_del (RTEMS_RTL_ALLOC_READ, *const_base);
   rtems_rtl_alloc_del (RTEMS_RTL_ALLOC_READ_EXEC, *text_base);
-  *text_base = *const_base = *data_base = *bss_base = NULL;
-}
+  *text_base = *const_base = *eh_base = *data_base = *bss_base = NULL;
+}
Index: cpukit/libdl/rtl-allocator.h
===================================================================
--- cpukit/libdl/rtl-allocator.h	(revision d51538bdbe5ea9e71a7205e39fcef387fbdb4b39)
+++ cpukit/libdl/rtl-allocator.h	(revision d2e31f70c12f6363cef79ffad781df6ec0acdfb5)
@@ -147,4 +147,6 @@
  * @param const_base Pointer to the const base pointer.
  * @param const_size The size of the read only section.
+ * @param eh_base Pointer to the eh base pointer.
+ * @param eh_size The size of the eh section.
  * @param data_base Pointer to the data base pointer.
  * @param data_size The size of the read/write secton.
@@ -156,4 +158,5 @@
 bool rtems_rtl_alloc_module_new (void** text_base, size_t text_size,
                                  void** const_base, size_t const_size,
+                                 void** eh_base, size_t eh_size,
                                  void** data_base, size_t data_size,
                                  void** bss_base, size_t bss_size);
@@ -164,9 +167,11 @@
  * @param text_base Pointer to the text base pointer.
  * @param const_base Pointer to the const base pointer.
+ * @param eh_base Pointer to the eh base pointer.
  * @param data_base Pointer to the data base pointer.
  * @param bss_base Pointer to the bss base pointer.
  */
 void rtems_rtl_alloc_module_del (void** text_base, void** const_base,
-                                 void** data_base, void** bss_base);
+                                 void** eh_base, void** data_base,
+                                 void** bss_base);
 
 #ifdef __cplusplus
Index: cpukit/libdl/rtl-debugger.c
===================================================================
--- cpukit/libdl/rtl-debugger.c	(revision d51538bdbe5ea9e71a7205e39fcef387fbdb4b39)
+++ cpukit/libdl/rtl-debugger.c	(revision d2e31f70c12f6363cef79ffad781df6ec0acdfb5)
@@ -46,8 +46,8 @@
 _rtld_linkmap_add (rtems_rtl_obj_t* obj)
 {
-  struct link_map* l = (struct link_map*)obj->detail;
+  struct link_map* l = obj->linkmap;
   struct link_map* prev;
-  uint32_t obj_num = obj->obj_num;
-  int i;
+  uint32_t         obj_num = obj->obj_num;
+  int              i;
 
   if (rtems_rtl_trace (RTEMS_RTL_TRACE_DETAIL))
@@ -79,6 +79,8 @@
 _rtld_linkmap_delete (rtems_rtl_obj_t* obj)
 {
-  struct link_map* l = (struct link_map*)obj->detail;
-  /* link_maps are allocated together if not 1 */
+  struct link_map* l = obj->linkmap;
+  /*
+   *  link_maps are allocated together if not 1
+   */
   struct link_map* e = l + obj->obj_num - 1;
 
@@ -91,6 +93,6 @@
     return;
   }
+
   if ((l->l_prev->l_next = e->l_next) != NULL)
     e->l_next->l_prev = l->l_prev;
-  return;
 }
Index: cpukit/libdl/rtl-elf.c
===================================================================
--- cpukit/libdl/rtl-elf.c	(revision d51538bdbe5ea9e71a7205e39fcef387fbdb4b39)
+++ cpukit/libdl/rtl-elf.c	(revision d2e31f70c12f6363cef79ffad781df6ec0acdfb5)
@@ -31,4 +31,5 @@
 #include "rtl-error.h"
 #include "rtl-trace.h"
+#include "rtl-unwind.h"
 #include "rtl-unresolved.h"
 
@@ -170,4 +171,7 @@
       return false;
 
+    /*
+     * Read the symbol details.
+     */
     if (is_rela)
       off = (obj->ooffset + symsect->offset +
@@ -247,5 +251,5 @@
       {
         if (rtems_rtl_trace (RTEMS_RTL_TRACE_RELOC))
-          printf ("rtl: rela: sym:%s(%-2d)=%08lx type:%-2d off:%08lx addend:%d\n",
+          printf ("rtl: rela: sym:%s(%d)=%08lx type:%d off:%08lx addend:%d\n",
                   symname, (int) ELF_R_SYM (rela->r_info), symvalue,
                   (int) ELF_R_TYPE (rela->r_info), rela->r_offset, (int) rela->r_addend);
@@ -257,5 +261,5 @@
       {
         if (rtems_rtl_trace (RTEMS_RTL_TRACE_RELOC))
-          printf ("rtl: rel: sym:%s(%-2d)=%08lx type:%-2d off:%08lx\n",
+          printf ("rtl: rel: sym:%s(%d)=%08lx type:%d off:%08lx\n",
                   symname, (int) ELF_R_SYM (rel->r_info), symvalue,
                   (int) ELF_R_TYPE (rel->r_info), rel->r_offset);
@@ -301,5 +305,5 @@
     rela.r_addend = reloc->rel[REL_R_ADDEND];
     if (rtems_rtl_trace (RTEMS_RTL_TRACE_RELOC))
-          printf ("rtl: rela: sym:%-2d type:%-2d off:%08lx addend:%d\n",
+          printf ("rtl: rela: sym:%d type:%d off:%08lx addend:%d\n",
                   (int) ELF_R_SYM (rela.r_info), (int) ELF_R_TYPE (rela.r_info),
                   rela.r_offset, (int) rela.r_addend);
@@ -314,5 +318,5 @@
     rel.r_info = reloc->rel[REL_R_INFO];
     if (rtems_rtl_trace (RTEMS_RTL_TRACE_RELOC))
-      printf ("rtl: rel: sym:%-2d type:%-2d off:%08lx\n",
+      printf ("rtl: rel: sym:%d type:%d off:%08lx\n",
               (int) ELF_R_SYM (rel.r_info), (int) ELF_R_TYPE (rel.r_info),
               rel.r_offset);
@@ -653,4 +657,9 @@
     flags = 0;
 
+    if (rtems_rtl_trace (RTEMS_RTL_TRACE_DETAIL))
+      printf ("rtl: section: %2d: type=%d flags=%08x link=%d info=%d\n",
+              section, (int) shdr.sh_type, (unsigned int) shdr.sh_flags,
+              (int) shdr.sh_link, (int) shdr.sh_info);
+
     switch (shdr.sh_type)
     {
@@ -708,7 +717,14 @@
 
       default:
-        if (rtems_rtl_trace (RTEMS_RTL_TRACE_WARNING))
-          printf ("rtl: unsupported section: %2d: type=%02d flags=%02x\n",
-                  section, (int) shdr.sh_type, (int) shdr.sh_flags);
+        /*
+         * See if there are architecture specific flags?
+         */
+        flags = rtems_rtl_elf_section_flags (obj, &shdr);
+        if (flags == 0)
+        {
+          if (rtems_rtl_trace (RTEMS_RTL_TRACE_WARNING))
+            printf ("rtl: unsupported section: %2d: type=%02d flags=%02x\n",
+                    section, (int) shdr.sh_type, (int) shdr.sh_flags);
+        }
         break;
     }
@@ -718,4 +734,11 @@
       char*  name;
       size_t len;
+
+      /*
+       * If link ordering this section must appear in the same order in memory
+       * as the linked-to section relative to the sections it loads with.
+       */
+      if ((shdr.sh_flags & SHF_LINK_ORDER) != 0)
+        flags |= RTEMS_RTL_OBJ_SECT_LINK;
 
       len = RTEMS_RTL_ELF_STRING_MAX;
@@ -730,4 +753,10 @@
         flags |= RTEMS_RTL_OBJ_SECT_DTOR;
 
+      if (rtems_rtl_elf_unwind_parse (obj, name, flags))
+      {
+        flags &= ~(RTEMS_RTL_OBJ_SECT_TEXT | RTEMS_RTL_OBJ_SECT_CONST);
+        flags |= RTEMS_RTL_OBJ_SECT_EH;
+      }
+
       if (!rtems_rtl_obj_add_section (obj, section, name,
                                       shdr.sh_size, shdr.sh_offset,
@@ -772,14 +801,17 @@
 }
 
-bool rtems_rtl_elf_load_details (rtems_rtl_obj_t* obj)
+static bool
+rtems_rtl_elf_load_linkmap (rtems_rtl_obj_t* obj)
 {
   rtems_chain_control* sections = NULL;
   rtems_chain_node*    node = NULL;
   size_t               mask = 0;
-  struct link_map*     l = NULL;
   int                  sec_num = 0;
+  section_detail*      sd;
   int                  i = 0;
 
-  /* caculate the size of sections' name. */
+  /*
+   * Caculate the size of sections' name.
+   */
 
   for (mask = RTEMS_RTL_OBJ_SECT_TEXT;
@@ -792,5 +824,4 @@
     {
       rtems_rtl_obj_sect_t* sect = (rtems_rtl_obj_sect_t*) node;
-
       if ((sect->size != 0) && ((sect->flags & mask) != 0))
       {
@@ -802,30 +833,29 @@
 
   obj->obj_num = 1;
-  obj->detail = rtems_rtl_alloc_new (RTEMS_RTL_ALLOC_OBJECT,
-                                     sizeof(struct link_map) +
-                                     sec_num * sizeof (section_detail), true);
-  if (!obj->detail)
-  {
-    rtems_rtl_set_error (ENOMEM, "no memory for obj global syms");
-    return false;
-  }
-
-  l = (struct link_map*) obj->detail;
-  l->name = obj->oname;
-  l->sec_num = sec_num;
-  l->sec_detail = (section_detail*) (l + 1);
-  l->rpathlen = 0;
-  l->rpath = NULL;
-  l->l_next = NULL;
-  l->l_prev = NULL;
-  l->sec_addr[rap_text] = obj->text_base;
-  l->sec_addr[rap_const] = obj->const_base;
-  l->sec_addr[rap_data] = obj->data_base;
-  l->sec_addr[rap_bss] = obj->bss_base;
-
-
-  section_detail* sd = l->sec_detail;
+  obj->linkmap = rtems_rtl_alloc_new (RTEMS_RTL_ALLOC_OBJECT,
+                                      sizeof(struct link_map) +
+                                      sec_num * sizeof (section_detail), true);
+  if (!obj->linkmap)
+  {
+    rtems_rtl_set_error (ENOMEM, "no memory for obj linkmap");
+    return false;
+  }
+
+  obj->linkmap->name = obj->oname;
+  obj->linkmap->sec_num = sec_num;
+  obj->linkmap->sec_detail = (section_detail*) (obj->linkmap + 1);
+  obj->linkmap->rpathlen = 0;
+  obj->linkmap->rpath = NULL;
+  obj->linkmap->l_next = NULL;
+  obj->linkmap->l_prev = NULL;
+  obj->linkmap->sec_addr[rap_text] = obj->text_base;
+  obj->linkmap->sec_addr[rap_const] = obj->const_base;
+  obj->linkmap->sec_addr[rap_data] = obj->data_base;
+  obj->linkmap->sec_addr[rap_bss] = obj->bss_base;
+
+  sd = obj->linkmap->sec_detail;
   sections = &obj->sections;
   node = rtems_chain_first (sections);
+
   for (mask = RTEMS_RTL_OBJ_SECT_TEXT;
        mask <= RTEMS_RTL_OBJ_SECT_BSS;
@@ -949,9 +979,21 @@
   rtems_rtl_symbol_obj_erase_local (obj);
 
-  if (!rtems_rtl_elf_load_details (obj))
-  {
-    return false;
-  }
-
+  if (!rtems_rtl_elf_load_linkmap (obj))
+  {
+    return false;
+  }
+
+  if (!rtems_rtl_elf_unwind_register (obj))
+  {
+    return false;
+  }
+
+  return true;
+}
+
+bool
+rtems_rtl_elf_file_unload (rtems_rtl_obj_t* obj)
+{
+  rtems_rtl_elf_unwind_deregister (obj);
   return true;
 }
Index: cpukit/libdl/rtl-elf.h
===================================================================
--- cpukit/libdl/rtl-elf.h	(revision d51538bdbe5ea9e71a7205e39fcef387fbdb4b39)
+++ cpukit/libdl/rtl-elf.h	(revision d2e31f70c12f6363cef79ffad781df6ec0acdfb5)
@@ -54,4 +54,16 @@
  */
 #define RTEMS_RTL_ELF_STRING_MAX (256)
+
+/**
+ * Architecture specific handler to translate unknown section flags to RTL
+ * section flags.
+ *
+ * @param obj The object file being relocated.
+ * @param shdr The ELF section header.
+ * @retval 0 Unknown or unsupported flags.
+ * @retval uint32_t RTL object file flags.
+ */
+uint32_t rtems_rtl_elf_section_flags (const rtems_rtl_obj_t* obj,
+                                      const Elf_Shdr*        shdr);
 
 /**
@@ -138,11 +150,4 @@
 
 /**
- * The ELF file details handler.
- *
- * @param obj Load the details of the obj.
- */
-bool rtems_rtl_elf_load_details (rtems_rtl_obj_t* obj);
-
-/**
  * The ELF format load handler.
  *
@@ -151,4 +156,11 @@
  */
 bool rtems_rtl_elf_file_load (rtems_rtl_obj_t* obj, int fd);
+
+/**
+ * The ELF format unload handler.
+ *
+ * @param obj The object to unload.
+ */
+bool rtems_rtl_elf_file_unload (rtems_rtl_obj_t* obj);
 
 /**
Index: cpukit/libdl/rtl-error.c
===================================================================
--- cpukit/libdl/rtl-error.c	(revision d51538bdbe5ea9e71a7205e39fcef387fbdb4b39)
+++ cpukit/libdl/rtl-error.c	(revision d2e31f70c12f6363cef79ffad781df6ec0acdfb5)
@@ -18,4 +18,5 @@
 #endif
 
+#include <errno.h>
 #include <stdio.h>
 #include <stdarg.h>
@@ -40,8 +41,14 @@
 {
   rtems_rtl_data_t* rtl = rtems_rtl_lock ();
-  int               last_errno = rtl->last_errno;
-  strncpy (message, rtl->last_error, sizeof (rtl->last_error));
-  rtems_rtl_unlock ();
-  return last_errno;
+  if (rtl != NULL)
+  {
+    int last_errno = rtl->last_errno;
+    strncpy (message, rtl->last_error, sizeof (rtl->last_error));
+    rtems_rtl_unlock ();
+    return last_errno;
+  }
+
+  strncpy(message, "RTL init error", max_message);
+
+  return EIO;
 }
-
Index: cpukit/libdl/rtl-mdreloc-arm.c
===================================================================
--- cpukit/libdl/rtl-mdreloc-arm.c	(revision d51538bdbe5ea9e71a7205e39fcef387fbdb4b39)
+++ cpukit/libdl/rtl-mdreloc-arm.c	(revision d2e31f70c12f6363cef79ffad781df6ec0acdfb5)
@@ -11,4 +11,6 @@
 #include <sys/types.h>
 #include <sys/stat.h>
+#include <unwind.h>
+#include <unwind-arm-common.h>
 
 #include <rtems/rtl/rtl.h>
@@ -16,4 +18,5 @@
 #include "rtl-error.h"
 #include "rtl-trace.h"
+#include "rtl-unwind.h"
 
 /*
@@ -24,4 +27,6 @@
 	(((uintptr_t)(x) & (sizeof(void *) - 1)) == 0)
 
+#define SHT_ARM_EXIDX  0x70000001 /* Section holds ARM unwind info. */
+
 static inline Elf_Addr
 load_ptr(void *where)
@@ -53,4 +58,22 @@
 }
 
+static inline Elf_SOff
+sign_extend31(Elf_Addr val)
+{
+  if (0x40000000 & val)
+    val =  ~((Elf_Addr)0x7fffffff) | (0x7fffffff & val);
+  return 0x7fffffff & val;
+}
+
+uint32_t
+rtems_rtl_elf_section_flags (const rtems_rtl_obj_t* obj,
+                             const Elf_Shdr*        shdr)
+{
+  uint32_t flags = 0;
+  if (shdr->sh_type == SHT_ARM_EXIDX)
+    flags = RTEMS_RTL_OBJ_SECT_EH | RTEMS_RTL_OBJ_SECT_LOAD;
+  return flags;
+}
+
 bool
 rtems_rtl_elf_rel_resolve_sym (Elf_Word type)
@@ -88,6 +111,9 @@
 
   switch (ELF_R_TYPE(rel->r_info)) {
-		case R_TYPE(NONE):
-			break;
+    case R_TYPE(NONE):
+      if (rtems_rtl_trace (RTEMS_RTL_TRACE_RELOC)) {
+        printf ("rtl: NONE %p in %s\n", where, rtems_rtl_obj_oname (obj));
+      }
+      break;
 
     case R_TYPE(CALL):    /* BL/BLX */
@@ -166,10 +192,15 @@
     case R_TYPE(ABS32):     /* word32 (S + A) | T */
     case R_TYPE(GLOB_DAT):  /* word32 (S + A) | T */
+    case R_TYPE(PREL31):    /* word32 (S + A) | T - P */
+    case R_TYPE(TARGET2):   /* Equivalent to REL32 */
       if (__predict_true(RELOC_ALIGNED_P(where))) {
         tmp = *where + symvalue;
         if (isThumb(symvalue))
           tmp |= 1;
-        if (ELF_R_TYPE(rel->r_info) == R_TYPE(REL32))
+        if (ELF_R_TYPE(rel->r_info) == R_TYPE(REL32) ||
+            ELF_R_TYPE(rel->r_info) == R_TYPE(TARGET2))
           tmp -= (Elf_Addr)where;
+        else if (ELF_R_TYPE(rel->r_info) == R_TYPE(PREL31))
+          tmp = sign_extend31(tmp - (Elf_Addr)where);
         *where = tmp;
       } else {
@@ -177,11 +208,14 @@
         if (isThumb(symvalue))
           tmp |= 1;
-        if (ELF_R_TYPE(rel->r_info) == R_TYPE(REL32))
+        if (ELF_R_TYPE(rel->r_info) == R_TYPE(REL32) ||
+            ELF_R_TYPE(rel->r_info) == R_TYPE(TARGET2))
           tmp -= (Elf_Addr)where;
+        else if (ELF_R_TYPE(rel->r_info) == R_TYPE(PREL31))
+          tmp = sign_extend31(tmp - (Elf_Addr)where);
         store_ptr(where, tmp);
       }
 
       if (rtems_rtl_trace (RTEMS_RTL_TRACE_RELOC))
-        printf ("rtl: REL32/ABS32/GLOB_DAT %p @ %p in %s",
+        printf ("rtl: REL32/ABS32/GLOB_DAT/PREL31/TARGET2 %p @ %p in %s\n",
                 (void *)tmp, where, rtems_rtl_obj_oname (obj));
       break;
@@ -307,5 +341,5 @@
       break;
 
-		default:
+    default:
       printf ("rtl: reloc unknown: sym = %lu, type = %lu, offset = %p, "
               "contents = %p\n",
@@ -316,8 +350,82 @@
                            "in non-PLT relocations",
                            sect->name, (uint32_t) ELF_R_TYPE(rel->r_info));
-			return false;
+      return false;
   }
 
-	return true;
-}
-
+  return true;
+}
+
+bool
+rtems_rtl_elf_unwind_parse (const rtems_rtl_obj_t* obj,
+                            const char*            name,
+                            uint32_t               flags)
+{
+  /*
+   * We location the EH sections in section flags.
+   */
+  return false;
+}
+
+bool
+rtems_rtl_elf_unwind_register (rtems_rtl_obj_t* obj)
+{
+  return true;
+}
+
+bool
+rtems_rtl_elf_unwind_deregister (rtems_rtl_obj_t* obj)
+{
+  obj->loader = NULL;
+  return true;
+}
+
+/* An exception index table entry.  */
+typedef struct __EIT_entry
+{
+  _uw fnoffset;
+  _uw content;
+} __EIT_entry;
+
+/* The exception index table location in the base module */
+extern __EIT_entry __exidx_start;
+extern __EIT_entry __exidx_end;
+
+/*
+ * A weak reference is in libgcc, provide a real version and provide a way to
+ * manage loaded modules.
+ *
+ * Passed in the return address and a reference to the number of records
+ * found. We set the start of the exidx data and the number of records.
+ */
+_Unwind_Ptr __gnu_Unwind_Find_exidx (_Unwind_Ptr return_address,
+                                     int*        nrec) __attribute__ ((__noinline__,
+                                                                       __used__,
+                                                                       __noclone__));
+
+_Unwind_Ptr __gnu_Unwind_Find_exidx (_Unwind_Ptr return_address,
+                                     int*        nrec)
+{
+  rtems_rtl_data_t* rtl;
+  rtems_chain_node* node;
+  __EIT_entry*      exidx_start = &__exidx_start;
+  __EIT_entry*      exidx_end = &__exidx_end;
+
+  rtl = rtems_rtl_lock ();
+
+  node = rtems_chain_first (&rtl->objects);
+  while (!rtems_chain_is_tail (&rtl->objects, node)) {
+    rtems_rtl_obj_t* obj = (rtems_rtl_obj_t*) node;
+    if (rtems_rtl_obj_text_inside (obj, (void*) return_address)) {
+      exidx_start = (__EIT_entry*) obj->eh_base;
+      exidx_end = (__EIT_entry*) (obj->eh_base + obj->eh_size);
+      break;
+    }
+    node = rtems_chain_next (node);
+  }
+
+  rtems_rtl_unlock ();
+
+  *nrec = exidx_end - exidx_start;
+
+  return (_Unwind_Ptr) exidx_start;
+}
Index: cpukit/libdl/rtl-mdreloc-bfin.c
===================================================================
--- cpukit/libdl/rtl-mdreloc-bfin.c	(revision d51538bdbe5ea9e71a7205e39fcef387fbdb4b39)
+++ cpukit/libdl/rtl-mdreloc-bfin.c	(revision d2e31f70c12f6363cef79ffad781df6ec0acdfb5)
@@ -7,4 +7,13 @@
 #include "rtl-error.h"
 #include "rtl-trace.h"
+#include "rtl-unwind.h"
+#include "rtl-unwind-dw2.h"
+
+uint32_t
+rtems_rtl_elf_section_flags (const rtems_rtl_obj_t* obj,
+                             const Elf_Shdr*        shdr)
+{
+  return 0;
+}
 
 bool
@@ -114,2 +123,22 @@
   return false;
 }
+
+bool
+rtems_rtl_elf_unwind_parse (const rtems_rtl_obj_t* obj,
+                            const char*            name,
+                            uint32_t               flags)
+{
+  return rtems_rtl_elf_unwind_dw2_parse (obj, name, flags);
+}
+
+bool
+rtems_rtl_elf_unwind_register (rtems_rtl_obj_t* obj)
+{
+  return rtems_rtl_elf_unwind_dw2_register (obj);
+}
+
+bool
+rtems_rtl_elf_unwind_deregister (rtems_rtl_obj_t* obj)
+{
+  return rtems_rtl_elf_unwind_dw2_deregister (obj);
+}
Index: cpukit/libdl/rtl-mdreloc-h8300.c
===================================================================
--- cpukit/libdl/rtl-mdreloc-h8300.c	(revision d51538bdbe5ea9e71a7205e39fcef387fbdb4b39)
+++ cpukit/libdl/rtl-mdreloc-h8300.c	(revision d2e31f70c12f6363cef79ffad781df6ec0acdfb5)
@@ -10,4 +10,13 @@
 #include "rtl-error.h"
 #include "rtl-trace.h"
+#include "rtl-unwind.h"
+#include "rtl-unwind-dw2.h"
+
+uint32_t
+rtems_rtl_elf_section_flags (const rtems_rtl_obj_t* obj,
+                             const Elf_Shdr*        shdr)
+{
+  return 0;
+}
 
 bool
@@ -100,2 +109,22 @@
   return false;
 }
+
+bool
+rtems_rtl_elf_unwind_parse (const rtems_rtl_obj_t* obj,
+                            const char*            name,
+                            uint32_t               flags)
+{
+  return rtems_rtl_elf_unwind_dw2_parse (obj, name, flags);
+}
+
+bool
+rtems_rtl_elf_unwind_register (rtems_rtl_obj_t* obj)
+{
+  return rtems_rtl_elf_unwind_dw2_register (obj);
+}
+
+bool
+rtems_rtl_elf_unwind_deregister (rtems_rtl_obj_t* obj)
+{
+  return rtems_rtl_elf_unwind_dw2_deregister (obj);
+}
Index: cpukit/libdl/rtl-mdreloc-i386.c
===================================================================
--- cpukit/libdl/rtl-mdreloc-i386.c	(revision d51538bdbe5ea9e71a7205e39fcef387fbdb4b39)
+++ cpukit/libdl/rtl-mdreloc-i386.c	(revision d2e31f70c12f6363cef79ffad781df6ec0acdfb5)
@@ -16,4 +16,13 @@
 #include "rtl-error.h"
 #include "rtl-trace.h"
+#include "rtl-unwind.h"
+#include "rtl-unwind-dw2.h"
+
+uint32_t
+rtems_rtl_elf_section_flags (const rtems_rtl_obj_t* obj,
+                             const Elf_Shdr*        shdr)
+{
+  return 0;
+}
 
 bool
@@ -102,2 +111,22 @@
   return true;
 }
+
+bool
+rtems_rtl_elf_unwind_parse (const rtems_rtl_obj_t* obj,
+                            const char*            name,
+                            uint32_t               flags)
+{
+  return rtems_rtl_elf_unwind_dw2_parse (obj, name, flags);
+}
+
+bool
+rtems_rtl_elf_unwind_register (rtems_rtl_obj_t* obj)
+{
+  return rtems_rtl_elf_unwind_dw2_register (obj);
+}
+
+bool
+rtems_rtl_elf_unwind_deregister (rtems_rtl_obj_t* obj)
+{
+  return rtems_rtl_elf_unwind_dw2_deregister (obj);
+}
Index: cpukit/libdl/rtl-mdreloc-lm32.c
===================================================================
--- cpukit/libdl/rtl-mdreloc-lm32.c	(revision d51538bdbe5ea9e71a7205e39fcef387fbdb4b39)
+++ cpukit/libdl/rtl-mdreloc-lm32.c	(revision d2e31f70c12f6363cef79ffad781df6ec0acdfb5)
@@ -10,4 +10,13 @@
 #include "rtl-error.h"
 #include "rtl-trace.h"
+#include "rtl-unwind.h"
+#include "rtl-unwind-dw2.h"
+
+uint32_t
+rtems_rtl_elf_section_flags (const rtems_rtl_obj_t* obj,
+                             const Elf_Shdr*        shdr)
+{
+  return 0;
+}
 
 bool
@@ -119,2 +128,22 @@
   return false;
 }
+
+bool
+rtems_rtl_elf_unwind_parse (const rtems_rtl_obj_t* obj,
+                            const char*            name,
+                            uint32_t               flags)
+{
+  return rtems_rtl_elf_unwind_dw2_parse (obj, name, flags);
+}
+
+bool
+rtems_rtl_elf_unwind_register (rtems_rtl_obj_t* obj)
+{
+  return rtems_rtl_elf_unwind_dw2_register (obj);
+}
+
+bool
+rtems_rtl_elf_unwind_deregister (rtems_rtl_obj_t* obj)
+{
+  return rtems_rtl_elf_unwind_dw2_deregister (obj);
+}
Index: cpukit/libdl/rtl-mdreloc-m68k.c
===================================================================
--- cpukit/libdl/rtl-mdreloc-m68k.c	(revision d51538bdbe5ea9e71a7205e39fcef387fbdb4b39)
+++ cpukit/libdl/rtl-mdreloc-m68k.c	(revision d2e31f70c12f6363cef79ffad781df6ec0acdfb5)
@@ -16,4 +16,6 @@
 #include "rtl-error.h"
 #include "rtl-trace.h"
+#include "rtl-unwind.h"
+#include "rtl-unwind-dw2.h"
 
 static inline int overflow_8_check(int value)
@@ -29,4 +31,11 @@
     return true;
   return false;
+}
+
+uint32_t
+rtems_rtl_elf_section_flags (const rtems_rtl_obj_t* obj,
+                             const Elf_Shdr*        shdr)
+{
+  return 0;
 }
 
@@ -147,2 +156,22 @@
   return false;
 }
+
+bool
+rtems_rtl_elf_unwind_parse (const rtems_rtl_obj_t* obj,
+                            const char*            name,
+                            uint32_t               flags)
+{
+  return rtems_rtl_elf_unwind_dw2_parse (obj, name, flags);
+}
+
+bool
+rtems_rtl_elf_unwind_register (rtems_rtl_obj_t* obj)
+{
+  return rtems_rtl_elf_unwind_dw2_register (obj);
+}
+
+bool
+rtems_rtl_elf_unwind_deregister (rtems_rtl_obj_t* obj)
+{
+  return rtems_rtl_elf_unwind_dw2_deregister (obj);
+}
Index: cpukit/libdl/rtl-mdreloc-mips.c
===================================================================
--- cpukit/libdl/rtl-mdreloc-mips.c	(revision d51538bdbe5ea9e71a7205e39fcef387fbdb4b39)
+++ cpukit/libdl/rtl-mdreloc-mips.c	(revision d2e31f70c12f6363cef79ffad781df6ec0acdfb5)
@@ -10,4 +10,13 @@
 #include "rtl-error.h"
 #include "rtl-trace.h"
+#include "rtl-unwind.h"
+#include "rtl-unwind-dw2.h"
+
+uint32_t
+rtems_rtl_elf_section_flags (const rtems_rtl_obj_t* obj,
+                             const Elf_Shdr*        shdr)
+{
+  return 0;
+}
 
 bool
@@ -189,2 +198,22 @@
   return true;
 }
+
+bool
+rtems_rtl_elf_unwind_parse (const rtems_rtl_obj_t* obj,
+                            const char*            name,
+                            uint32_t               flags)
+{
+  return rtems_rtl_elf_unwind_dw2_parse (obj, name, flags);
+}
+
+bool
+rtems_rtl_elf_unwind_register (rtems_rtl_obj_t* obj)
+{
+  return rtems_rtl_elf_unwind_dw2_register (obj);
+}
+
+bool
+rtems_rtl_elf_unwind_deregister (rtems_rtl_obj_t* obj)
+{
+  return rtems_rtl_elf_unwind_dw2_deregister (obj);
+}
Index: cpukit/libdl/rtl-mdreloc-moxie.c
===================================================================
--- cpukit/libdl/rtl-mdreloc-moxie.c	(revision d51538bdbe5ea9e71a7205e39fcef387fbdb4b39)
+++ cpukit/libdl/rtl-mdreloc-moxie.c	(revision d2e31f70c12f6363cef79ffad781df6ec0acdfb5)
@@ -11,4 +11,13 @@
 #include "rtl-error.h"
 #include "rtl-trace.h"
+#include "rtl-unwind.h"
+#include "rtl-unwind-dw2.h"
+
+uint32_t
+rtems_rtl_elf_section_flags (const rtems_rtl_obj_t* obj,
+                             const Elf_Shdr*        shdr)
+{
+  return 0;
+}
 
 bool
@@ -87,2 +96,22 @@
   return false;
 }
+
+bool
+rtems_rtl_elf_unwind_parse (const rtems_rtl_obj_t* obj,
+                            const char*            name,
+                            uint32_t               flags)
+{
+  return rtems_rtl_elf_unwind_dw2_parse (obj, name, flags);
+}
+
+bool
+rtems_rtl_elf_unwind_register (rtems_rtl_obj_t* obj)
+{
+  return rtems_rtl_elf_unwind_dw2_register (obj);
+}
+
+bool
+rtems_rtl_elf_unwind_deregister (rtems_rtl_obj_t* obj)
+{
+  return rtems_rtl_elf_unwind_dw2_deregister (obj);
+}
